# -*- coding:Utf-8 -*-
#!/usr/bin/python

# \copyleft Denis LE FUR \copyright
# This work may be distributed and/or mofified under the conditions
# or the LaTeX Project Public Licence, either v1.3 or (at your option)
# any later version. The latest version is in
#   http://www.latex-project.org/lppl/
# This work consists of the files suitefn.py.


import pygtk
pygtk.require("2.0")
import gtk  

import os
import sys
import platform

if platform.system()=="Linux" :
   	sys.path.append("../SystemeLinux/")
else :
    sys.path.append("../SystemeWindows/")
from pro_sortie import *


sys.path.append("../Divers/")
from pro_divers import *
from textelibre import *
sys.path.append("../Supplements/Pro-suites/")
from supp_suitefn import *





class Suitefn:



    #-------------------------------------------------------------
    # Initialisations, création de la fenêtre principale
    #-------------------------------------------------------------
    def __init__(self):
        interface = gtk.Builder()
        interface.add_from_file('suitefn.glade')
        self.initialisation=True
        self.radiobuttonMetapost = interface.get_object("radiobuttonMetapost")
        self.radiobuttonAsymptote = interface.get_object("radiobuttonAsymptote")
        self.entryNS = interface.get_object("entryNS")
        self.entryVI = interface.get_object("entryVI")
        self.entryExpression = interface.get_object("entryExpression")
        self.entryNT = interface.get_object("entryNT")
        self.entryXmin = interface.get_object("entryXmin")
        self.entryXmax = interface.get_object("entryXmax")
        self.entryYmin = interface.get_object("entryYmin")
        self.entryYmax = interface.get_object("entryYmax")
        self.entryUx = interface.get_object("entryUx")
        self.entryUy = interface.get_object("entryUy")
        self.entryLx = interface.get_object("entryLx")
        self.entryLy = interface.get_object("entryLy")
        self.entryGx = interface.get_object("entryGx")
        self.entryGy = interface.get_object("entryGy")
        self.entryNTS = interface.get_object("entryNTS")
        self.entryXTS = interface.get_object("entryXTS")
        self.comboboxCS = interface.get_object("comboboxCS")    
        self.comboboxCT = interface.get_object("comboboxCT")
        self.comboboxPositionTS = interface.get_object("comboboxPositionTS")
        self.buttonCompiler = interface.get_object("buttonCompiler")
        self.progressbar = interface.get_object("progressbar")
        self.buttonCodeGraphique = interface.get_object("buttonCodeGraphique")
        self.buttonPdf = interface.get_object("buttonPdf")
        self.textviewCodeProfessor = interface.get_object("textviewCodeProfessor")
        self.textviewSupp = interface.get_object("textviewSupp")
        self.labelEntete = interface.get_object("labelEntete")
        self.checkbuttonTitreGauche = interface.get_object("checkbuttonTitreGauche")
        self.checkbuttonTitreCentre = interface.get_object("checkbuttonTitreCentre")
        self.checkbuttonTitreDroite = interface.get_object("checkbuttonTitreDroite")
        self.checkbuttonCacher = interface.get_object("checkbuttonCacher")
        self.checkbuttonTS = interface.get_object("checkbuttonTS")
        self.checkbuttonTexteLibre = interface.get_object("checkbuttonTexteLibre")
        self.entryTitreGauche = interface.get_object("entryTitreGauche")
        self.entryTitreCentre = interface.get_object("entryTitreCentre")
        self.entryTitreDroite = interface.get_object("entryTitreDroite")    
        self.labelXTS = interface.get_object("labelXTS")
        self.labelNTS = interface.get_object("labelNTS")    
        self.labelPTS = interface.get_object("labelPTS")
        
        #Indique si la compilation est lancée
        self.Etat_Compilation=False
        
        #fenêtre textlibre
        self.TL=Textelibre(self)
        self.TL.windowTL.set_title("Textes supplémentaires")
        self.TL.windowTL.hide()
        
        
        interface.connect_signals(self)
        self.maj_codeprofessor()
        maj_codesupp(self)
        
        #Couleurs par défaut
        self.comboboxCS.set_active(1) #bleu
        self.comboboxCT.set_active(0) #rouge
        
        #Position par défaut : Haut
        self.comboboxPositionTS.set_active(0)
        
        #désactivation
        self.comboboxPositionTS.set_sensitive(False)
        self.entryXTS.set_sensitive(False)
        self.entryNTS.set_sensitive(False)
        self.labelXTS.set_sensitive(False)
        self.labelPTS.set_sensitive(False)
        self.labelNTS.set_sensitive(False)
        
        
        self.textviewCodeProfessor.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))
        self.textviewSupp.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(couleurfond))

        self.entryTitreGauche.set_sensitive(False)
        self.entryTitreCentre.set_sensitive(False)
        self.entryTitreDroite.set_sensitive(False)
        
        self.initialisation=False


    #-------------------------------------------------------------  
    # Fin de l'application  
    #-------------------------------------------------------------
    def on_windowSuitefn_destroy(self, widget):
        gtk.main_quit()

    #-------------------------------------------------------------
    # Met à jour le code à insérer
    #-------------------------------------------------------------  
    def maj_codeprofessor(self):
        text_view=self.textviewCodeProfessor
        Texte_Code="\\begin{pro-suitefn}{1}\n"
        NS=self.entryNS.get_text()
        NS=NS.replace('\\','@')
        VI=self.entryVI.get_text()
        VI=VI.replace('\\','@')
        Expression=self.entryExpression.get_text()
        Expression=Expression.replace('\\','@')
        CouleurSuite=self.comboboxCS.get_active_text()
        CouleurSuite=Nom_Couleur(CouleurSuite)
        CouleurTermes=self.comboboxCT.get_active_text()
        CouleurTermes=Nom_Couleur(CouleurTermes)
        NT=self.entryNT.get_text()
        NT=NT.replace('\\','@')
        Xmin=self.entryXmin.get_text()
        Xmin=Xmin.replace('\\','@')
        Xmax=self.entryXmax.get_text()
        Xmax=Xmax.replace('\\','@')
        Ymin=self.entryYmin.get_text()
        Ymin=Ymin.replace('\\','@')
        Ymax=self.entryYmax.get_text()
        Ymax=Ymax.replace('\\','@')
        Ux=self.entryUx.get_text()
        Ux=Ux.replace('\\','@')
        Uy=self.entryUy.get_text()
        Uy=Uy.replace('\\','@')
        Lx=self.entryLx.get_text()
        Lx=Lx.replace('\\','@')
        Ly=self.entryLy.get_text()
        Ly=Ly.replace('\\','@')
        Gx=self.entryGx.get_text()
        Gx=Gx.replace('\\','@') 
        Gy=self.entryGy.get_text()
        Gy=Gy.replace('\\','@') 
        Texte_Code=Texte_Code+"[\""+NS+"\","+VI+"],\n"
        if self.checkbuttonCacher.get_active()==True:
            Texte_Code=Texte_Code+"["+NT+","+"\""+CouleurTermes+"\",\"cache\"],\n"
        else:
            Texte_Code=Texte_Code+"["+NT+","+"\""+CouleurTermes+"\"],\n"
        Texte_Code=Texte_Code+"["+Expression+","+"\""+CouleurSuite+"\"],\n"     
        Texte_Code=Texte_Code+Xmin+","+Xmax+","+Ymin+","+Ymax+",\n"
        Texte_Code=Texte_Code+Ux+","+Uy+",\n"
        Texte_Code=Texte_Code+Lx+","+Ly+",\n"
        Texte_Code=Texte_Code+Gx+","+Gy+",\n"
        Texte_Code=Texte_Code+"// ----------------- début des options\n"
        Texte_Code=Texte_Code+"[\n"
        Options=self.traiter_options()
        Texte_Code=Texte_Code+Options
        Texte_Code=Texte_Code+"]\n"
        Texte_Code=Texte_Code+"// ----------------- fin des options\n"
        Texte_Code=Texte_Code+"\\end{pro-suitefn}"
        ecrire_texte_textview(Texte_Code,text_view)




    #-------------------------------------------------------------
    # Mise à jour après des changements dans la définition
    #-------------------------------------------------------------      
    def on_entryNS_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryVI_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryExpression_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryNT_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
            
        
    def on_entryXmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryXmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmin_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryYmax_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryUx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryUy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False 
        
    def on_entryLx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryLy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        self.Etat_Compilation=False
        
    def on_entryGx_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False
        
    def on_entryGy_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 

    def on_checkbuttonTS_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTS.get_active()==True:
            self.comboboxPositionTS.set_sensitive(True)
            self.entryXTS.set_sensitive(True)
            self.entryNTS.set_sensitive(True)
            self.labelXTS.set_sensitive(True)
            self.labelPTS.set_sensitive(True)
            self.labelNTS.set_sensitive(True)
        else:
            self.comboboxPositionTS.set_sensitive(False)
            self.entryXTS.set_sensitive(False)
            self.entryNTS.set_sensitive(False)
            self.labelXTS.set_sensitive(False)
            self.labelPTS.set_sensitive(False)
            self.labelNTS.set_sensitive(False)
        self.Etat_Compilation=False
        
    def on_checkbuttonCacher_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False
        
    def on_comboboxCT_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 
        
    def on_comboboxCS_changed(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)  
        self.Etat_Compilation=False 
        
    def on_checkbuttonTexteLibre_clicked(self,widget):
        self.maj_codeprofessor()
        maj_codesupp(self)
        if self.checkbuttonTexteLibre.get_active()==True:
            self.TL.windowTL.show_all()
        else:
            self.TL.windowTL.hide()
        self.Etat_Compilation=False
        


    #-------------------------------------------------------------
    # Mise à jour du label du nom de paquet à utiliser
    #-------------------------------------------------------------          
    def on_radiobuttonMetapost_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-suites}")
        self.Etat_Compilation=False
        
    def on_radiobuttonAsymptote_clicked(self,widget):
        self.labelEntete.set_label("Placer dans l\'entête : \\usepackage[xcas]{pro-asy-suites}")        
        self.Etat_Compilation=False
        

    #-------------------------------------------------------------
    # Traitement des options    
    #-------------------------------------------------------------  
    def traiter_options(self):
        Options=""
        if self.checkbuttonTitreGauche.get_active()==True :
           Options="[\"titre-gauche\",\""
           TitreGauche=self.entryTitreGauche.get_text()
           TitreGauche=traiter_texte(TitreGauche)
           Options=Options+TitreGauche
           Options=Options+"\"],\n"
           
        if self.checkbuttonTitreCentre.get_active()==True :
           Options=Options+"[\"titre-centre\",\""
           TitreCentre=self.entryTitreCentre.get_text()
           TitreCentre=traiter_texte(TitreCentre)
           Options=Options+TitreCentre
           Options=Options+"\"],\n" 
           
        if self.checkbuttonTitreDroite.get_active()==True :
           Options=Options+"[\"titre-droite\",\""
           TitreDroite=self.entryTitreDroite.get_text()
           TitreDroite=traiter_texte(TitreDroite)
           Options=Options+TitreGauche
           
        if self.checkbuttonTS.get_active()==True :
            XTS=self.entryXTS.get_text()
            XTS=XTS.replace('\\','@')
            NTS=self.entryNTS.get_text()
            NTS=NTS.replace('\\','@')
            PositionTS=self.comboboxPositionTS.get_active_text()
            PositionTS=Nom_Position(PositionTS)
            CouleurSuite=self.comboboxCS.get_active_text()
            CouleurSuite=Nom_Couleur(CouleurSuite)
            Options=Options+"[\"texte-courbe\","+XTS+",\"$"+NTS+"$\",\""+PositionTS+"\",\""+CouleurSuite+"\"],\n"
           
               
        Options=Options+self.TL.Texte_Libre
        Options=Options+"[\"rien\"]\n"
        return Options

    #-------------------------------------------------------------
    # Mise à jour suite au traitement des options   
    #-------------------------------------------------------------          
    def on_checkbuttonTitreGauche_clicked(self,widget):
        if self.checkbuttonTitreGauche.get_active()==False :
            self.entryTitreGauche.set_sensitive(False)
        else :
            self.entryTitreGauche.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_checkbuttonTitreCentre_clicked(self,widget):
        if self.checkbuttonTitreCentre.get_active()==False :
            self.entryTitreCentre.set_sensitive(False)
        else :
            self.entryTitreCentre.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
            
    def on_checkbuttonTitreDroite_clicked(self,widget):
        if self.checkbuttonTitreDroite.get_active()==False :
            self.entryTitreDroite.set_sensitive(False)
        else :
            self.entryTitreDroite.set_sensitive(True)
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False
        
    def on_entryTitreGauche_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()
        self.Etat_Compilation=False

    def on_entryTitreCentre_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 

    def on_entryTitreDroite_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
    def on_comboboxPositionTS_changed(self,widget): 
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
            
    def on_entryXTS_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False 
        
    def on_entryNTS_changed(self,widget):   
        self.traiter_options()
        self.maj_codeprofessor()    
        self.Etat_Compilation=False
        
            
        

    #-------------------------------------------------------------
    # lancement de la compilation   
    #-------------------------------------------------------------  
    def on_buttonTester_pressed(self,widget):
        self.progressbar.set_text("en cours...")
        
    def on_buttonTester_released(self,widget):
        # création du fichier codeprofessor à partir du buffer
        text_buffer=self.textviewCodeProfessor.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codeprofessor(Texte)
        # création du fichier codesupp à partir du buffer
        text_buffer=self.textviewSupp.get_buffer()
        start_iter = text_buffer.get_start_iter()
        end_iter = text_buffer.get_end_iter()
        Texte=text_buffer.get_text(start_iter, end_iter, include_hidden_chars=True)
        ecrire_codesupp(Texte)  
        if self.radiobuttonMetapost.get_active()==True:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-suites}")    
            compiler("mp")
            self.Etat_Compilation=True
            afficher("mp","suitefn1")
        else:
            ecrire_enteteprofessor("\\usepackage[xcas]{pro-asy-suites}")    
            compiler("asy")
            self.Etat_Compilation=True
            afficher("asy","suitefn1")
        self.progressbar.set_text("")
        
            
    #-------------------------------------------------------------
    # Affichage du code graphique   
    #-------------------------------------------------------------  
    def on_buttonCodeGraphique_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_codegraphique("mp","suitefn1",self.Etat_Compilation)
        else:
            afficher_codegraphique("asy","suitefn1",self.Etat_Compilation)

    #-------------------------------------------------------------
    # Affichage de l'image  
    #-------------------------------------------------------------  
    def on_buttonPdf_clicked(self,widget):
        if self.radiobuttonMetapost.get_active()==True: 
            afficher_imagepng("mp","suitefn1",self.Etat_Compilation)
        else:
            afficher_imagepng("asy","suitefn1",self.Etat_Compilation)           


            
#-------------------------------------------------------------          
#-------------------------------------------------------------      
# Boucle principale
#-------------------------------------------------------------
#-------------------------------------------------------------
if __name__ == "__main__":
    Suitefn()
    gtk.main()

